#include "main.h"

namespace conv {

   int ConvBaseC::Verify() {
      this->LogFunction(_T("Verify"));

      if(!wxFileName().FileExists(fnmSrc.GetFullPath())) {
         wxLogMessage(_T("\tfile doesn't exist: %s"), fnmSrc.GetFullPath().c_str());
         ::LogFunctionEnd();
         return 0;
      } else if(!wxFileName().IsFileReadable(fnmSrc.GetFullPath())) {
         wxLogMessage(_T("\tfile isn't readable: %s"), fnmSrc.GetFullPath().c_str());
         ::LogFunctionEnd();
         return 0;
      }
      ::LogFunctionEnd();
      return 1;
   }

   int ConvBaseC::OpenAndVerify() {
      this->Verify();

      this->LogFunction(_T("OpenAndVerify"));

      if(!this->fileSrc.Open(fnmSrc.GetFullPath(), wxFile::read)) {
         wxLogMessage(_T("\tfailed opening file %s"), fnmSrc.GetFullPath().c_str());
         ::LogFunctionEnd();
         return 0;
      }

      //this->bVerified = true;
      ::LogFunctionEnd();
      return 1;
   }

   void ConvBaseC::Close() {
      this->fileSrc.Close();
   }

   int ConvBaseC::WriteToFile() {
      return 0;
   }
}
