//do not use!
//2008, Uli Hecht
//description file converter (UltraStar TEXT to SStar XML)

#include "main.h"

namespace desc {

   //todo: ustar parameter #relative, test

   /****************************************
     ULTRASTAR TEXT => SSTAR XML CONVERTER
   ****************************************/

   int TextConvC::OpenAndVerify() {
      this->bVerified = false;
      this->TextParser.fnmSrc = this->fnmSrc;
      if(this->TextParser.OpenAndVerify()) {
         this->bVerified = true;
         return 1;
      }
      return 0;
   }

   int TextConvC::ReadHeader() {
      if(!this->bVerified)
         if(!this->OpenAndVerify())
            return 0;
      if(this->TextParser.ReadHeader()) {
         this->bReadHeader = true;
         return 1;
      }
      return 0;
   }

   int TextConvC::Conv() {
      if(!bVerified) {
         wxLogMessage(_T("%s"), _T("desc::TextConvC::Conv():"));
         wxLogMessage(_T("%s"), _T("\tfile not verified, call OpenAndVerify() first"));
         return 0;
      }
      if(!this->bReadHeader)
         this->ReadHeader();

      wxLogMessage(_T("%s"), _T("desc::TextConvC::Conv():"));

      XMLNode xM; //main node
      XMLNode xN; //active node
      XMLNode xT; //temporary node

      ///write header
      xM = XMLNode::createXMLTopNode(_T("MELODY"), FALSE);
      //node: <MELODY>
      xM.addAttribute(_T("xmlns"), _T("http://www.singstargame.com"));
      xM.addAttribute(_T("xmlns:xsi"), _T("http://www.w3.org/2001/XMLSchema-instance"));
      xM.addAttribute(_T("Version"), _T("1"));
      xM.addAttribute(_T("Tempo"), wxString()<< this->TextParser.nBpm);
      xM.addAttribute(_T("FixedTempo"), _T("No"));
      xM.addAttribute(_T("Resolution"), _T("Demisemiquaver")); //not documented properly in ustar
      xM.addAttribute(_T("Genre"), this->strGenre);
      xM.addAttribute(_T("Year"), wxString()<< this->nYear);
      xM.addAttribute(_T("xsi:schemaLocation"),
                      _T("http://www.singstargame.com http://15GMS-SINGSQL/xml_schema/melody.xsd"));
      xM.addAttribute(_T("m2xVersion"), _T("060110")); //unknown
      xM.addAttribute(_T("audioVersion"), _T("1")); //unknown
      xN = xM.addChild(_T("TRACK"));
      //node: <TRACK>
      xN.addAttribute(_T("Name"), _T("Player1")); //unknown
      if(this->strOptArtist.IsEmpty())
         xN.addAttribute(_T("Artist"), this->TextParser.strArtist);
      else
         xN.addAttribute(_T("Artist"), this->strOptArtist);
      xN = xN.getParentNode();
      //node: <MELODY>

      ///begin conversion
      TextParserC::TextEntryT* EntryLast;
      TextParserC::TextEntryT* EntryTmp;
      int nEmptyBeats; //SStar XML saves NOTE nodes with lyric attribute set to "" for empty beats

      //open sentence tag, insert gap
      xN = xN.addChild(_T("SENTENCE"));
      xN.addAttribute(_T("Singer"), _T("Group"));    //unknown
      xT = xN.addChild(_T("LABEL"));                 //unknown
      xT.addAttribute(_T("Name"), _T("Bar Marker")); //unknown
      xT.addAttribute(_T("Delay"), _T("13"));        //unknown
      EntryTmp = new TextParserC::TextEntryT;
      EntryLast->nStart = 0; //todo: GAP
      EntryLast->nDuration = 0;
      EntryLast = EntryTmp;
      xT = xN.addChild(_T("NOTE"));
      xT.addAttribute(_T("MidiNote"), _T("0"));
      xT.addAttribute(_T("Duration"), wxString()<<EntryLast->nDuration);
      xT.addAttribute(_T("Lyric"), _T(""));

      //conversion loop
      for(unsigned int i = 0; i < this->TextParser.nEntryCnt; i++) {
         //add syllable
         nEmptyBeats = this->TextParser.Entry[i].nStart
                       - (EntryLast->nStart + EntryLast->nDuration);
         if(nEmptyBeats != 0) {
            xT = xN.addChild(_T("NOTE"));
            xT.addAttribute(_T("MidiNote"), _T("0"));
            xT.addAttribute(_T("Duration"), wxString()<< nEmptyBeats);
            xT.addAttribute(_T("Lyric"), _T(""));
         }
         if(this->TextParser.Entry[i].nDuration != 0) {
            xT = xN.addChild(_T("NOTE"));
            xT.addAttribute(_T("MidiNote"), wxString()<< this->TextParser.Entry[i].nMidiNote);
            xT.addAttribute(_T("Duration"), wxString()<< this->TextParser.Entry[i].nDuration);
            xT.addAttribute(_T("Lyric"), this->TextParser.Entry[i].strSyllable->c_str());
         }

         EntryLast = &(this->TextParser.Entry[i]);

         //new line
         if(this->TextParser.Entry[i].nType == TextParserC::TextEntryT::TEXTENTRYTYPE_LINEINFO) {
            xN = xN.getParentNode().addChild(_T("SENTENCE"));
            if(this->TextParser.bRelative)
               EntryLast->nStart = 0;
         }
      }

      delete EntryTmp;

      //todo: assertion: sum of durations in xml == start + duration of last entry in txt

      this->bufDest = xM.createXMLString(1, &this->nBufDestLen);
      wxLogMessage(_T("content:\n%s"), this->bufDest);

      return 1;
   }

   void TextConvC::Close() {
      this->TextParser.Close();
   }

   int TextConvC::WriteToFile() {
      wxLogMessage(_T("%s"), _T("desc::TextConvC::WriteToFile():"));
      wxFile fileDest;
      if(!fileDest.Open(this->fnmDest.GetFullPath())) {
         wxLogError(_T("%s"), _T("\tfailed opening file"));
         return 0;
      }
      wxString strTmp(this->bufDest, this->nBufDestLen);
      if(!fileDest.Write(strTmp, wxConvISO8859_1)) {
         wxLogError(_T("%s"), _T("\tfailed writing to file"));
         return 0;
      }

      return 1;
   }

   TextConvC::~TextConvC() {
   }

   /********************
     PARSER BASE CLASS
   ********************/

   int ParserBaseC::OpenAndVerify() {
      return INH::Verify();
   }

   int ParserBaseC::ReadHeader() { return 0; }
   int ParserBaseC::Parse()      { return 0; }

   /************************
     ULTRASTAR TEXT PARSER
   ************************/

   int TextParserC::OpenAndVerify() {
      if(!INH::OpenAndVerify())
         return 0;

      //this->textfileSrc = wxTextFile::wxTextFile();
      if(this->textfileSrc.Open(this->fnmSrc.GetFullPath())) {
         this->bVerified = true;
         return 1;
      }

      return 0;
   }

   int TextParserC::ReadHeader() {
      if(!bVerified)
         if(!this->OpenAndVerify())
            return 0;

      wxLogMessage(_T("%s"), _T("desc::TextParserC::ReadHeader():"));

      this->nEntryCnt = 0;
      this->bRelative = false;
      wxString strLn;
      for(strLn = this->textfileSrc.GetFirstLine(); !this->textfileSrc.Eof();
          strLn = this->textfileSrc.GetNextLine())
      {
         if(strLn.Mid(0, 1) == _T("#")) {
            wxString strAttrName = strLn.BeforeFirst(_T(':')).Mid(1).Trim().MakeUpper();
            wxString strAttrVal = strLn.AfterFirst(_T(':')).Trim();

            wxLogMessage(_T("\t%s: %s"), strAttrName.c_str(), strAttrVal.c_str());

                 if(strAttrName == _T("TITLE"))    this->strTitle = strAttrVal;
            else if(strAttrName == _T("ARTIST"))   this->strArtist = strAttrVal;
            else if(strAttrName == _T("MP3"))      this->strTargetAudio = strAttrVal;
            else if(strAttrName == _T("BPM"))      strAttrVal.ToDouble(&this->nBpm);
            else if(strAttrName == _T("GAP"))      strAttrVal.ToULong(&this->nGapAudio);
            else if(strAttrName == _T("VIDEO"))    this->strTargetVid = strAttrVal;
            else if(strAttrName == _T("VIDEOGAP")) strAttrVal.ToULong(&this->nGapVid);
            else if(strAttrName == _T("RELATIVE"))
               this->bRelative = (strAttrVal.MakeLower() == _T("yes")) ? true : false;

         } else if(strLn.Mid(0, 1) == _T(":") || strLn.Mid(0, 1) == _T("-")) {
            this->nEntryCnt++;
         }
      }

      wxLogMessage(_T("\tfile has %d data entries"), this->nEntryCnt);
      this->bReadHeader = true;
      return 1;
   }

   int TextParserC::Parse() {
      if(!bVerified) {
         wxLogMessage(_T("%s"), _T("desc::TextParserC::Parse():"));
         wxLogMessage(_T("%s"), _T("\tfile not verified, call OpenAndVerify() first"));
         return 0;
      }
      if(!this->bReadHeader)
         this->ReadHeader();

      wxLogMessage(_T("%s"), _T("desc::TextParserC::Parse():"));

      ///allocate entry-array, read data
      this->Entry = new TextEntryT[this->nEntryCnt];
      wxLogMessage(_T("%s"), _T("\tstart reading data"));
      int i = 0;
      wxStringTokenizer tokLn;
      wxString strToken;
      wxString strLn;
      for(strLn = this->textfileSrc.GetFirstLine(); !this->textfileSrc.Eof();
          strLn = this->textfileSrc.GetNextLine())
      {
         tokLn.SetString(strLn);
         strToken = tokLn.GetNextToken();
         if(strToken == _T(":")) {
            (this->Entry)[i].nType = TextEntryT::TEXTENTRYTYPE_SYLLABLE;
            tokLn.GetNextToken().ToULong(&((this->Entry)[i].nStart));
            tokLn.GetNextToken().ToULong(&((this->Entry)[i].nDuration));
            tokLn.GetNextToken().ToULong(&((this->Entry)[i].nMidiNote));
            (this->Entry)[i].strSyllable = new wxString(tokLn.GetNextToken());
            i++;
         } else if(strToken == _T("-")) {
            (this->Entry)[i].nType = TextEntryT::TEXTENTRYTYPE_LINEINFO;
            tokLn.GetNextToken().ToULong(&((this->Entry)[i].nStart));
            if(tokLn.HasMoreTokens()) {
               tokLn.GetNextToken().ToULong(&((this->Entry)[i].nDuration));
               (this->Entry)[i].nDuration-= (this->Entry)[i].nStart;
            } else {
               (this->Entry)[i].nDuration = 0;
            }
            (this->Entry)[i].strSyllable = new wxString(); //neccessary for later errors ;)
            (this->Entry)[i].nMidiNote = 0;
            i++;
         }
      }

      i--;
      wxLogMessage(_T("\tlast entry:\n\t\t\tStart:%d\n\t\t\tDuration:%d\n\t\t\tNote:%d\n\t\t\t")
                   _T("Syllable:%s\n\t\t\tType:%d"),
                   (this->Entry)[i].nStart,
                   (this->Entry)[i].nDuration,
                   (this->Entry)[i].nMidiNote,
                   (this->Entry)[i].strSyllable->c_str(),
                   (this->Entry)[i].nType);

      return 1;
   }

   void TextParserC::Close() {
      delete[] this->Entry;
   }

   /*******************
     SSTAR XML PARSER
   *******************/

   int XmlParserC::OpenAndVerify() {
      //INH::OpenAndVerify();
      //todo: verify...
      wxLogMessage(_T("%s"), _T("desc::XmlParserC::OpenAndVerify():"));

      this->bVerified = false;
      this->xMain = XMLNode::openFileHelper(this->fnmSrc.GetFullPath().c_str(), _T("MELODY"));
      if(!this->xMain.isEmpty()) {
         this->bVerified = true;
         return 1;
      }
      return 0;
      /*if(res.error == eXMLErrorNone) {
         this->bVerified = true;
         return 1;
      }
      wxLogMessage(_T("\tin file %s"), this->fnmSrc.GetFullPath().c_str());
      wxLogMessage(_T("\t\t%s"), this->xMain.getError(res.error));
      wxLogMessage(_T("\t\tin line %d, column %d"), res.nLine, res.nColumn);
      return 0;*/
   }

   int XmlParserC::ReadHeader() {
      if(!bVerified)
         if(!this->OpenAndVerify())
            return 0;

      wxLogMessage(_T("%s"), _T("XmlParserC::ReadHeader():"));

      //this->xMain = this->xMain.getChildNode(_T("MELODY"));

      this->strGenre = wxString(this->xMain.getAttribute(_T("Genre")));
      wxString(this->xMain.getAttribute(_T("Tempo"))).ToDouble(&this->nBpm);
      wxString(this->xMain.getAttribute(_T("Year"))).ToLong(&this->nYear);
      this->strArtist =
         wxString(this->xMain.getChildNode(_T("TRACK")).getAttribute(_T("Artist")));

      wxLogMessage(_T("\tartist: %s\n\t\tyear: %u\n\t\tgenre: %s\n\t\ttempo: %u"),
                   this->strArtist.c_str(),
                   this->nYear,
                   this->strGenre.c_str(),
                   this->nBpm);

      return 1;
   }
}
