#include "main.h"

unsigned int   LogWindowAndFileC::nNested = 0;

/***********
 APPLICATION
 ***********/

IMPLEMENT_APP(App)

struct test {
   double a;
   double b;
};

///APPLICATION INIT
bool App::OnInit() {
   if(!wxApp::OnInit()) return false;

   gui::frame = new gui::frmMain(APP_TITLE);
   gui::frame->Show(true);

   LogWindowAndFileC* frmLog =
      new LogWindowAndFileC(gui::frame, APP_TITLE _T(" - Log"), true, true, _T("./log.txt"),
                            _T("Welcome to *SStar MOD Tools* ") APP_VER _T(" by RiverBlenny"));
   wxLog::SetActiveTarget(frmLog);

   audio::Init();

   ///tests
   //if(!gTestAudio_MibEncC_FromWav()) return false;

   return true;
}

///LOG
void LogWindowAndFileC::DoLogString(const wxChar* msg, time_t timestamp) {
   wxString strMsg;
   strMsg.Append(_T('\t'), LogWindowAndFileC::nNested)<< msg;
   this->fileLog.AddLine(wxString()<< wxDateTime(timestamp).FormatTime()<<
                         _T(":\t")<< strMsg);
   this->fileLog.Write();
   wxLogWindow::DoLogString(strMsg.c_str(), timestamp);
}

void LogWindowAndFileC::DoLog(wxLogLevel level, const wxChar* msg, time_t timestamp) {
   this->DoLogString(msg, timestamp);
}

///TESTING

int gTestAudio_MibEncC_FromMp3() {
   audio::MibEncC MibEnc;

   MibEnc.nSrcFormat      = audio::MibEncC::SRCFORMAT_MP3;
   MibEnc.fnmSrc          = _T("./audio.mp3");
   MibEnc.fnmDest         = _T("./audio.mib");
   MibEnc.fnmHeader       = _T("./audio.mih");
   MibEnc.bWriteDirectly  = true;
   MibEnc.nAdpcmLoopStart = -1;
   MibEnc.nInterleave     = 1024;
   MibEnc.nChannels       = 2;
   if(!MibEnc.OpenAndVerify())   return 0;
   if(!MibEnc.Encode())          return 0;
   if(!MibEnc.WriteHeaderFile()) return 0;
   MibEnc.Close();

   return 1;
}

int gTestAudio_MibEncC_FromWav() {
   audio::MibEncC MibEnc;

   MibEnc.nSrcFormat = audio::MibEncC::SRCFORMAT_WAVE;
   MibEnc.fnmSrc          = _T("./audio.mib.wav");
   MibEnc.fnmDest         = _T("./audio.mib.wav.mib");
   MibEnc.fnmHeader       = _T("./audio.mib.wav.mih");
   MibEnc.bWriteDirectly  = true;
   MibEnc.nAdpcmLoopStart = -1;
   MibEnc.nInterleave     = 1024;
   MibEnc.nChannels       = 2;
   if(!MibEnc.OpenAndVerify())   return 0;
   if(!MibEnc.Encode())          return 0;
   if(!MibEnc.WriteHeaderFile()) return 0;
   MibEnc.Close();

   return 1;
}

int gTestAudio_Mp3DecC_BlockWritingModes() {
   wxFile        file[2];
   unsigned char byte[2];
   if(!file[0].Open(_T("./SINGLEBLOCK.wav"), wxFile::read)) return 0;
   if(!file[1].Open(_T("./MULTIBLOCK.wav"), wxFile::read))  return 0;
   for(int i = 0; i < (file[0].Length() > file[1].Length()) ? file[1].Length() : file[0].Length();
       ++i)
   {
      if(!file[0].Read(&(byte[0]), 1)) return 0;
      if(!file[1].Read(&(byte[1]), 1)) return 0;
      if(byte[0] != byte[1])
         wxLogMessage(_T("%.7d: %.2x != %.2x"), i, byte[0], byte[1]);
   }

   return 1;
}

int gTestAudio_Mp3DecC() {
   audio::Mp3DecC Mp3Dec;

   Mp3Dec.fnmSrc = _T("./audio.mp3");
   Mp3Dec.fnmDest = _T("./audio2.wav");
   Mp3Dec.SetOutputBufferMode(audio::Mp3DecC::BUFFERMODE_SINGLEBLOCK);
   Mp3Dec.ReadHeader();
   if(!Mp3Dec.Decode())      return 0;
   if(!Mp3Dec.WriteToFile()) return 0;
   Mp3Dec.Close();

   return 1;
}

int gTestAudio_WavDecC() {
   audio::WavDecC WavDec;

   WavDec.fnmSrc = _T("./Test4BitMsAdpcmIn.wav");
   WavDec.fnmDest = _T("./Test4BitMsAdpcmIn.wav.WavDecC.wav");
   if(!WavDec.ReadHeader())  return 0;
   if(!WavDec.Decode())      return 0;
   if(!WavDec.WriteToFile()) return 0;
   WavDec.Close();

   return 1;
}
