//JAN-2008 rivR_bl3Ny

#if !defined(SSTARMOD_MAIN_H)
#define SSTARMOD_MAIN_H

//placating the god of coding, Abacus ;)
#define FUN

//if defined, only one block will be encoded in audio::MibEncC (for debugging purpose)
//#define SSTARMOD_1BLOCK


#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif


#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

using namespace std;

#include <wx/app.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/file.h>
#include <wx/dir.h>
#include <wx/filename.h>
#include <wx/listctrl.h>
#include <wx/dialog.h>
#include <wx/textfile.h>
#include <wx/tokenzr.h>
#include <algorithm>
#include <vector>

#include <mpg123/mpg123.h>
#include "sndfile.hh"

#include <math.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>

#define APP_NAME  _T("SStar MOD Tools")
#define APP_VER   _T("0.4.8")
#define APP_TITLE APP_NAME _T(" v") APP_VER

#define MAX(_a,_b)   ((_a)>(_b) ? (_a):(_b))
#define MIN(_a,_b)   ((_a)<(_b) ? (_a):(_b))
#define CLAMP(_v,_min,_max) MIN(MAX(_v,_min),_max);

///SETTINGS

//settings class
class SettingsC {
   public:
      SettingsC() { }

      enum VIDEOTYPE {
         VIDEOTYPE_MPEG,
         VIDEOTYPE_AVI,
         VIDEOTYPE_IPU,
         VIDEOTYPE_ENUM_LEN
      };
      enum AUDIOTYPE {
         AUDIOTYPE_MP3,
         AUDIOTYPE_PCM,
         AUDIOTYPE_MIB,
         AUDIOTYPE_ENUM_LEN
      };
      enum DESCTYPE {
         DESCTYPE_TEXT,
         DESCTYPE_XML,
         DESCTYPE_ENUM_LEN
      };

      wxString   strTitle;
      wxString   strArtist;
      wxFileName fnmVid;
      wxFileName fnmAudio;
      wxFileName fnmDesc;
      wxFileName fnmVidHeader;
      wxFileName fnmAudioHeader;
      VIDEOTYPE  nVidType;
      AUDIOTYPE  nAudioType;
      DESCTYPE   nDescType;
      bool       bUseAudioFromVid;
      wxString   strGenre;
      int        nYear;

      int        nTrackIndex;
};

///LOGGING

class LogWindowAndFileC : public wxLogWindow {
   protected:
      ///members
      wxString strFileName;

      ///overloaded
      virtual void DoLog(wxLogLevel level, const wxChar* msg, time_t timestamp);
      virtual void DoLogString(const wxChar* msg, time_t timestamp);

   public:
      ///members
      wxTextFile          fileLog;
      static unsigned int nNested;

      ///constructor, destructor
      LogWindowAndFileC(wxFrame* parent, const wxChar* title,
                        bool show = true, bool passToOld = true,
                        const wxString& filename, const wxString& AppInfo)
         : wxLogWindow(parent, title, show, passToOld)
      {
         this->strFileName = filename;
         if(wxFileName().FileExists(filename)) {
            if(!this->fileLog.Open(this->strFileName))
               return;
         } else {
            if(!this->fileLog.Create(this->strFileName))
               return;
         }
         this->fileLog.AddLine(_T(""));
         this->fileLog.AddLine(_T(""));
         this->fileLog.AddLine(wxString()<< _T("***")<< wxDateTime().SetToCurrent().FormatDate());
         this->fileLog.AddLine(AppInfo);
         this->fileLog.AddLine(_T(""));
         this->fileLog.Write();
      }
      virtual ~LogWindowAndFileC() {
         fileLog.Close();
      }

      DECLARE_NO_COPY_CLASS(LogWindowAndFileC)
};

inline void LogFunction(const wxString& ns, const wxString& cls, const wxString& fn) {
   wxLogMessage(_T("%s::%s::%s()"), ns.c_str(), cls.c_str(), fn.c_str());
   ++(LogWindowAndFileC::nNested);
}
inline void LogFunction(const wxString& context, const wxString& fn) {
   wxLogMessage(_T("%s::%s()"), context.c_str(), fn.c_str());
   ++(LogWindowAndFileC::nNested);
}
inline void LogFunction(const wxString& fn) {
   wxLogMessage(_T("%s()"), fn.c_str());
   ++(LogWindowAndFileC::nNested);
}
inline void LogFunctionEnd() {
   --(LogWindowAndFileC::nNested);
}

///OTHERS

template <class T>
inline T SwapEndian(const T& tVal) {
   T tRet;

   unsigned char* cVal = (unsigned char*)(&tVal);
   unsigned char* cRet = (unsigned char*)(&tRet);

   for(size_t i = 0; i < sizeof(T); ++i)
      cRet[sizeof(T) - i - 1] = cVal[i];

   return tRet;
}

#include "gui.h"       //graphical user interface
#include "xmlParser.h" //xml parser used by desc.cpp
#include "convert.h"   //base class for parsing, conversion, de- and encoding
#include "desc.h"      //sstar xml description file conversion, sstar-xml and ustar-text parsing
#include "audio.h"     //uses libmpg123 and libsndfile for audio conversion, writes mih files

///APPLICATION

class App : public wxApp {
   public:
      ///overloaded
      virtual bool OnInit();

};

///TESTING
int gTestAudio_Mp3DecC_BlockWritingModes();
int gTestAudio_Mp3DecC();
int gTestAudio_MibEncC_FromMp3();
int gTestAudio_MibEncC_FromWav();
int gTestAudio_WavDecC();

#endif //SSTARMOD_MAIN_H
